<?php

class TypeBase
{
  public FormManager $FormManager;
  public Database $Database;
  public array $DatabaseCompareOperators = array();
  public bool $Hidden;

  function __construct(FormManager $FormManager)
  {
    $this->FormManager = &$FormManager;
    $this->Database = &$FormManager->Database;
    $this->Hidden = false;
  }

  function OnView(array $Item): ?string
  {
    return '';
  }

  function OnEdit(array $Item): string
  {
    return '';
  }

  function OnLoad(array $Item): ?string
  {
    return '';
  }  

  function OnCanLoad(array $Item): bool
  {
    return array_key_exists($Item['Name'], $_POST);
  }
  
  function OnLoadDb(array $Item): ?string
  {
    return $Item['Value'];
  }

  function OnSaveDb(array $Item): ?string
  {
    return $Item['Value'];
  }

  function DatabaseEscape(string $Value): string
  {
    return addslashes($Value);
  }

  function OnFilterName(array $Item): string
  {
    if (array_key_exists('SQL', $Item) and ($Item['SQL'] != ''))
      $SQL = '('.$Item['SQL'].') AS ';
      else $SQL = '';
    return $SQL.'`'.$Item['Name'].'`';
  }

  function OnFilterNameQuery(array $Item): string
  {
    if (array_key_exists('SQL', $Item) and ($Item['SQL'] != ''))
      $Output = '('.$Item['SQL'].') AS `'.$Item['Name'].'`, ('.$Item['SQL'].') AS `'.$Item['Name'].'_Filter`';
      else $Output = '`'.$Item['Name'].'`, `'.$Item['Name'].'` AS `'.$Item['Name'].'_Filter`';
    return $Output;
  }

  function Validate(array $Item): bool
  {
    return true;
  }

  function GetValidationFormat(): string
  {
    return '';
  }
}
