<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeDate extends TypeBase
{
  function __construct(FormManager $FormManager)
  {
    parent::__construct($FormManager);
    $this->DatabaseCompareOperators = array('Rovno' => '=', 'Nerovno' => '!=', 'Menší' => '<', 'Větší' => '>');
  }

  function OnView(array $Item): ?string
  {
    if ($Item['Value'] == null) return '';
    if ((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $Parts = getdate($Item['Value']);

    $Output = $Parts['mday'].'.'.$Parts['mon'].'.'.$Parts['year'];
    return $Output;
  }

  function OnEdit(array $Item): string
  {
    global $MonthNames;

    if (($Item['Value'] == null) or (($Item['Value'] !== null) and ((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == ''))))
    {
      $Item['Value'] = time();
      $IsNull = true;
    } else $IsNull = false;
    $Parts = getdate($Item['Value']);

    $Output = '';
    $Style = '';
    if (array_key_exists('Null', $Item) and $Item['Null'])
    {
      if (!$IsNull)
      {
        $Checked = ' checked="1"';
        $Style = 'style="display:inline;"';
      } else
      {
        $Checked = '';
        $Style = 'style="display:none;"';
      }
      $Output .= '<input type="checkbox" name="'.$Item['Name'].'-null"'.$Checked.' onclick="toggle(\''.
        $Item['Name'].'-day\');toggle(\''.$Item['Name'].'-month\');toggle(\''.$Item['Name'].'-year\');"/>';
    }

    // Day
    $Output .= '<select name="'.$Item['Name'].'-day" id="'.$Item['Name'].'-day" '.$Style.'>';
    for ($I = 1; $I <= 31; $I++)
    {
      if ($Parts['mday'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Month
   $Output .= '<select name="'.$Item['Name'].'-month" id="'.$Item['Name'].'-month" '.$Style.'>';
   for ($I = 1; $I <= 12; $I++)
    {
      if ($Parts['mon'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$MonthNames[$I].'</option>';
    }
    $Output .= '</select>';
    // Year
    $Output .= '<select name="'.$Item['Name'].'-year" id="'.$Item['Name'].'-year" '.$Style.'>';
    for ($I = 1900; $I < 2100; $I++)
    {
      if ($Parts['year'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    return $Output;
  }

  function OnLoad(array $Item): ?string
  {
    if (!array_key_exists($Item['Name'].'-null', $_POST) and array_key_exists('Null', $Item) and ($Item['Null'] == true)) return null;
      else return mktime(0, 0, 0, $_POST[$Item['Name'].'-month'], $_POST[$Item['Name'].'-day'], $_POST[$Item['Name'].'-year']);
  }

  function OnCanLoad(array $Item): bool
  {
    return array_key_exists($Item['Name'].'-null', $_POST) or (array_key_exists($Item['Name'].'-day', $_POST) and 
      array_key_exists($Item['Name'].'-month', $_POST) and array_key_exists($Item['Name'].'-year', $_POST));
  }

  function OnLoadDb(array $Item): ?string
  {
    return MysqlDateToTime($Item['Value']);
  }

  function OnSaveDb(array $Item): ?string
  {
    if ($Item['Value'] == null) return null;
      else return date('Y-m-d', $Item['Value']);
  }

  function DatabaseEscape(string $Value): string
  {
    return '"'.addslashes($Value).'"';
  }
}
