<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeInteger extends TypeBase
{
  function __construct(FormManager $FormManager)
  {
    parent::__construct($FormManager);
    $this->DatabaseCompareOperators = array('Rovno' => '=', 'Nerovno' => '!=', 'Menší' => '<', 'Větší' => '>');
  }

  function OnView(array $Item): ?string
  {
    $Output = $Item['Value'];
    return $Output;
  }

  function OnEdit(array $Item): string
  {
    $Output = '<input type="text" name="'.$Item['Name'].'" value="'.$Item['Value'].'"/>';
    return $Output;
  }

  function OnLoad(array $Item): ?string
  {
    return $_POST[$Item['Name']];
  }

  function Validate(array $Item): bool
  {
    if ($Item['Null'] and ($Item['Value'] == '')) return true;
    return preg_match('/^\-*[0-9\.]+$/', $Item['Value']);
  }

  function GetValidationFormat(): string
  {
    return 'číselná hodnota';
  }
}
