<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeOneToMany extends TypeBase
{
  public array $EditActions;

  function OnView(array $Item): ?string
  {
    $Type = $this->FormManager->Type->TypeDefinitionList[$Item['Type']];
    if ($Item['Value'] != '')
    {
      $Output = '<a href="?t='.$Type['Parameters']['Table'].'&amp;a='.
        'view'.'&amp;i='.$Item['Value'].'">'.$Item['Filter'].'</a>';
    } else $Output = '';
    return $Output;
  }

  function OnEdit(array $Item): string
  {
    $Output = '<select name="'.$Item['Name'].'" id="'.$Item['Name'].'">';
    $Type = $this->FormManager->Type->TypeDefinitionList[$Item['Type']];
    if (array_key_exists('Condition', $Type['Parameters'])) $Where = ' WHERE '.$Type['Parameters']['Condition'];
      else $Where = '';
    if (array_key_exists('Null', $Item) and $Item['Null'])
    {
      if ($Item['Value'] == NULL) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value=""'.$Selected.'></option>';
    }
    if (array_key_exists('View', $Type['Parameters'])) $Table = $Type['Parameters']['View'];
      else $Table = $Type['Parameters']['Table'];
    $DbResult = $this->Database->query('SELECT '.$Type['Parameters']['Name'].' AS `Name`,'.$Type['Parameters']['Id'].' AS `Id` FROM '.$Table.''.$Where.' ORDER BY `Name`');
    while ($DbRow = $DbResult->fetch_assoc())
    {
      if ($Item['Value'] == $DbRow['Id']) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$DbRow['Id'].'"'.$Selected.'>'.$DbRow['Name'].'</option>';
    }
    $Output .= '</select>';
    if ($this->FormManager->ShowRelation)
    {
      $URL = '';
      if (array_key_exists('OnPreset', $Item))
      {
        $Preset = call_user_func($Item['OnPreset'], $Item['Values']);
        $URL = str_replace('&', '&amp;', '&'.http_build_query($Preset));
      }
      $Output .=  '<img src="'.$this->FormManager->Root.'/images/add.png" alf="Přidat" language="javascript" '.
        'onclick="return popupwindow(&quot;'.$this->FormManager->Root.'/is/?a=addsub&amp;t='.$Table.'&amp;r='.$Item['Name'].'&amp;rt='.$Item['Type'].$URL.'&quot;,&quot;test&quot;);" style="cursor:hand;cursor:pointer"/>';
      $Output .=  '<img src="'.$this->FormManager->Root.'/images/select.png" alf="Vybrat" language="javascript" '.
        'onclick="return popupwindow(&quot;'.$this->FormManager->Root.'/is/?a=select&amp;t='.$Table.'&amp;r='.$Item['Name'].'&quot;,&quot;test&quot;);" style="cursor:hand;cursor:pointer"/>';
    }
    return $Output;
  }

  function OnLoad(array $Item): ?string
  {
    if ($_POST[$Item['Name']] == '') return NULL;
      else return $_POST[$Item['Name']];
  }

  function OnLoadDb(array $Item): ?string
  {
    if ($Item['Value'] == '') return NULL;
      else return $Item['Value'];
  }

  function OnFilterName(array $Item): string
  {
    return '`'.$Item['Name'].'_Filter`';
  }

  function OnFilterNameQuery(array $Item): string
  {
    $Type = $this->FormManager->Type->TypeDefinitionList[$Item['Type']];
    //if ($Item['Value'] != '')
    //{
      if (array_key_exists('View', $Type['Parameters'])) $Table = $Type['Parameters']['View'];
        else $Table = $Type['Parameters']['Table'];
      $Output = '`'.$Item['Name'].'`, (SELECT '.$Type['Parameters']['Name'].''.
        ' AS `Name` FROM '.$Table.' WHERE `'.
        $Type['Parameters']['Id'].'`=`TX`.`'.$Item['Name'].'`) AS `'.$Item['Name'].'_Filter`';
    //} else $Output = '`'.$Item['Name'].'`, `'.$Item['Name'].'` AS `'.$Item['Name'].'_Filter`';
    return $Output;
  }
}
