<?php

function GetMimeTypes(): array
{
  return array(
  '7z'    => array('application/x-7z-compressed'),
  'ai'    => array('application/postscript'),
  'aif'   => array('audio/x-aiff'),
  'aifc'  => array('audio/x-aiff'),
  'aiff'  => array('audio/x-aiff'),
  'asf'   => array('video/x-ms-asf'),
  'atom'  => array('application/atom+xml'),
  'avi'   => array('video/x-msvideo'),
  'bin'   => array('application/octet-stream','application/macbinary'),
  'bmp'   => array('image/bmp'),
  'cab'   => array('application/x-cab'),
  'cpt'   => array('application/mac-compactpro'),
  'class' => array('application/octet-stream'),
  'css'   => array('text/css'),
  'csv'   => array('text/x-comma-separated-values', 'application/vnd.ms-excel'),
  'deb'   => array('application/x-debian-package'),
  'dbk'   => array('application/docbook+xml'),
  'dir'   => array('application/x-director'),
  'dcr'   => array('application/x-director'),
  'doc'   => array('application/msword'),
  'dmg'   => array('application/x-apple-diskimage'),
  'dms'   => array('application/octet-stream'),
  'dvi'   => array('application/x-dvi'),
  'dxr'   => array('application/x-director'),
  'dll'   => array('application/octet-stream', 'application/x-msdos-program'),
  'eml'   => array('message/rfc822'),
  'exe'   => array('application/x-msdos-program', 'application/octet-stream'),
  'eps'   => array('application/postscript'),
  'gif'   => array('image/gif'),
  'gtar'  => array('application/x-gtar'),
  'gz'    => array('application/x-gzip'),
  'htm'   => array('text/html'),
  'html'  => array('text/html'),
  'hqx'   => array('application/mac-binhex40'),
  'ics'   => array('text/calendar'),
  'iso'   => array('application/x-iso9660-image'),
  'jar'   => array('application/java-archive'),
  'jpeg'  => array('image/jpeg', 'image/pjpeg'),
  'jpg'   => array('image/jpeg', 'image/pjpeg'),
  'jpe'   => array('image/jpeg', 'image/pjpeg'),
  'js'    => array('application/x-javascript'),
  'json'  => array('application/json'),
  'lha'   => array('application/octet-stream'),
  'log'   => array('text/plain', 'text/x-log'),
  'lzh'   => array('application/octet-stream'),
  'midi'  => array('audio/midi'),
  'mid'   => array('audio/midi'),
  'mif'   => array('application/vnd.mif'),
  'mp2'   => array('audio/mpeg'),
  'mp3'   => array('audio/mpeg'),
  'mov'   => array('video/quicktime'),
  'movie' => array('video/x-sgi-movie'),
  'mpe'   => array('video/mpeg'),
  'mpeg'  => array('video/mpeg'),
  'mpg'   => array('video/mpeg'),
  'mpga'  => array('audio/mpeg'),
  'msi'   => array('application/x-msi'),
  'oda'   => array('application/oda'),
  'odb'   => array('application/vnd.oasis.opendocument.database'),
  'odc'   => array('application/vnd.oasis.opendocument.chart'),
  'odf'   => array('application/vnd.oasis.opendocument.forumla'),
  'odg'   => array('application/vnd.oasis.opendocument.graphics'),
  'odi'   => array('application/vnd.oasis.opendocument.image'),
  'odm'   => array('application/vnd.oasis.opendocument.text-master'),
  'odp'   => array('application/vnd.oasis.opendocument.presentation'),
  'ods'   => array('application/vnd.oasis.opendocument.spreadsheet'),
  'odt'   => array('application/vnd.oasis.opendocument.text'),
  'ogg'   => array('application/ogg'),
  'otg'   => array('application/vnd.oasis.opendocument.graphics-template'),
  'oth'   => array('application/vnd.oasis.opendocument.web'),
  'otp'   => array('application/vnd.oasis.opendocument.presentation-template'),
  'ots'   => array('application/vnd.oasis.opendocument.spreadsheet-template'),
  'ott'   => array('application/vnd.oasis.opendocument.template'),
  'pdf'   => array('application/pdf', 'application/x-download'),
  'php'   => array('application/x-httpd-php'),
  'php3'  => array('application/x-httpd-php'),
  'php4'  => array('application/x-httpd-php'),
  'php5'  => array('application/x-httpd-php'),
  'phps'  => array('application/x-httpd-php-source'),
  'phtml' => array('application/x-httpd-php'),
  'png'   => array('image/png', 'image/x-png'),
  'pps'   => array('application/vnd.ms-powerpoint'),
  'ppt'   => array('application/powerpoint'),
  'ps'    => array('application/postscript'),
  'psd'   => array('application/x-photoshop', 'image/x-photoshop'),
  'qt'    => array('video/quicktime'),
  'ra'    => array('audio/x-realaudio'),
  'ram'   => array('audio/x-pn-realaudio'),
  'rar'   => array('application/rar'),
  'rm'    => array('audio/x-pn-realaudio'),
  'rpm'   => array('audio/x-pn-realaudio-plugin', 'application/x-redhat-package-manager'),
  'rss'   => array('application/rss+xml'),
  'rtf'   => array('text/rtf'),
  'rtx'   => array('text/richtext'),
  'rv'    => array('video/vnd.rn-realvideo'),
  'sea'   => array('application/octet-stream'),
  'shtml' => array('text/html'),
  'sit'   => array('application/x-stuffit'),
  'smi'   => array('application/smil'),
  'smil'  => array('application/smil'),
  'so'    => array('application/octet-stream'),
  'swf'   => array('application/x-shockwave-flash'),
  'tar'   => array('application/x-tar'),
  'torrent' => array('application/x-bittorrent'),
  'text'  => array('text/plain'),
  'tif'   => array('image/tiff'),
  'tiff'  => array('image/tiff'),
  'tgz'   => array('application/x-tar'),
  'txt'   => array('text/plain'),
  'wav'   => array('audio/x-wav'),
  'wbxml' => array('application/wbxml'),
  'wmlc'  => array('application/wmlc'),
  'wpd'   => array('application/vnd.wordperfect'),
  'word'  => array('application/msword', 'application/octet-stream'),
  'xhtml' => array('application/xhtml+xml'),
  'xht'   => array('application/xhtml+xml'),
  'xl'    => array('application/excel'),
  'xls'   => array('application/excel', 'application/vnd.ms-excel'),
  'xml'   => array('text/xml'),
  'xsl'   => array('text/xml'),
  'zip'   => array('application/x-zip', 'application/zip', 'application/x-zip-compressed')
  );
}