<?php

class NewsSourceVismo extends NewsSource
{

  function Import(): string
  {
    $Output = parent::Import();
    $Content = file_get_contents_curl($this->URL);

    $BlockStart = '<h2 class="cvi text-to-speech">Přehled dokumentů</h2>';
    $BlockEnd = '</ul>';
    $Content = GetTextBetween($Content, $BlockStart, $BlockEnd);
    if ($Content == '')
    {
      $Output .= 'Main block not isolated.</br>';
      return $Output;
    }

    $ItemStart = '<li>';
    $ItemEnd = "</li>";
    while (strpos($Content, $ItemStart) !== false)
    {
      $Item = GetTextBetween($Content, $ItemStart, $ItemEnd);
      $NewsItem = new NewsItem();

      $NewsItem->Link = GetUrlBase($this->URL).html_entity_decode(GetTextBetween($Item, '<a href="', '">'));
      $NewsItem->Title = html_entity_decode(GetTextBetween($Item, '', '</a>'));
      $Date = GetTextBetween($Item, '<span>(', ')</span>');
      $NewsItem->Date = HumanDateToTime($Date);
      $NewsItem->Category = $this->Category;
      if (strpos($Item, '<div>') !== false)
      {
        $NewsItem->Content = html_entity_decode(GetTextBetween($Item, '<div>', '</div>'));
      }

      $NewsItem->Author = 'Automat';
      $NewsItem->Database = $this->Database;
      $this->NewsItems[] = $NewsItem;
    }
    return $Output;
  }
}
